/*
DROP TABLE doc_sp_t
/
DROP TABLE doc_t
/
DROP TABLE pers_t
/
*/

CREATE TABLE pers_t (
  pers_id NUMBER PRIMARY KEY,
  pers_fio VARCHAR2(1000) NOT NULL
)      
/

CREATE TABLE doc_t (
  doc_id NUMBER PRIMARY KEY,
  write_date DATE NOT NULL    
)
/      
      
CREATE TABLE doc_sp_t (
  pos_id  NUMBER PRIMARY KEY,
  doc_id  NUMBER NOT NULL REFERENCES doc_t (doc_id),
  pers_id NUMBER NOT NULL REFERENCES pers_t (pers_id)
)
/      
/*
DELETE FROM doc_sp_t
/
DELETE FROM doc_t
/
DELETE FROM pers_t
/
*/

INSERT INTO pers_t (pers_id, pers_fio)   
VALUES (1, '')
/

INSERT INTO doc_t (doc_id, write_date)   
VALUES (1, '01.01.2024')
/

INSERT INTO doc_sp_t (pos_id, doc_id, pers_id)   
VALUES (1, 1, 1)
/

INSERT INTO pers_t (pers_id, pers_fio)   
VALUES (2, '')
/

INSERT INTO doc_sp_t (pos_id, doc_id, pers_id)   
VALUES (2, 1, 2)
/
---------------------------------
pers_t
  pers_id pers_fio
    1       
    2          
---------------------------------    
doc_t    
  doc_id write_date
    1      01.01.2024
---------------------------------    
doc_sp_t    
  pos_id doc_id pers_id
    1      1      1
    2      1      2
---------------------------------

INSERT INTO pers_t (pers_id, pers_fio)   
VALUES (3, '')
/

INSERT INTO doc_t (doc_id, write_date)   
VALUES (2, '01.01.2025')
/

INSERT INTO doc_sp_t (pos_id, doc_id, pers_id)   
VALUES (3, 2, 1)
/

INSERT INTO doc_sp_t (pos_id, doc_id, pers_id)   
VALUES (4, 2, 2)
/

INSERT INTO doc_sp_t (pos_id, doc_id, pers_id)   
VALUES (5, 2, 3)
/

UPDATE pers_t SET pers_fio = '' WHERE pers_id = 1
/

---------------------------------
pers_t
  pers_id pers_fio
    1       
    2       
    3       
---------------------------------
doc_t
  doc_id write_date
    1      01.01.2024
    2      01.01.2025
---------------------------------
doc_sp_t
  pos_id doc_id pers_id
    1      1      1
    2      1      2
    3      2      1
    4      2      2
    5      2      3
---------------------------------

SELECT d.doc_id, d.write_date, sp.pos_id, sp.pers_id, p.pers_fio FROM doc_t d INNER JOIN doc_sp_t sp ON sp.doc_id = d.doc_id INNER JOIN pers_t p ON p.pers_id = sp.pers_id
ORDER BY d.doc_id, sp.pos_id

doc_id write_date   pos_id pers_id pers_fio
  1      01.01.2024   1      1       
  1      01.01.2024   2      2       
  2      01.01.2025   3      1       
  2      01.01.2025   4      2       
  2      01.01.2025   5      3       
---------------------------------

