/*
DROP TABLE doc_sp_t
/
DROP TABLE doc_t
/
DROP TABLE pers_t
/
DROP TABLE rev_t
/
*/

CREATE TABLE rev_t (
  rev_id NUMBER PRIMARY KEY
)      
/

CREATE TABLE pers_t (
  vpers_id NUMBER PRIMARY KEY,
  beg_id  NUMBER NOT NULL REFERENCES rev_t (rev_id),
  end_id  NUMBER NOT NULL REFERENCES rev_t (rev_id),
  pers_id NUMBER NOT NULL,
  pers_fio VARCHAR2(1000) NOT NULL
)      
/
CREATE INDEX ix_pers_t ON pers_t (beg_id, end_id, pers_id)
/

CREATE TABLE doc_t (
  vdoc_id NUMBER PRIMARY KEY,
  beg_id  NUMBER NOT NULL REFERENCES rev_t (rev_id),
  end_id  NUMBER NOT NULL REFERENCES rev_t (rev_id),
  doc_id NUMBER NOT NULL,
  write_date DATE NOT NULL    
)
/      
CREATE INDEX ix_doc_t ON doc_t (beg_id, end_id, doc_id)
/
      
CREATE TABLE doc_sp_t (
  vpos_id  NUMBER PRIMARY KEY,
  beg_id  NUMBER NOT NULL REFERENCES rev_t (rev_id),
  end_id  NUMBER NOT NULL REFERENCES rev_t (rev_id),
  pos_id  NUMBER NOT NULL,
  vdoc_id  NUMBER NOT NULL REFERENCES doc_t (vdoc_id),
  vpers_id NUMBER NOT NULL REFERENCES pers_t (vpers_id)
)
/      
CREATE INDEX ix_doc_sp_t ON doc_sp_t (beg_id, end_id, pos_id)
/
/*
DELETE FROM doc_sp_t
/
DELETE FROM doc_t
/
DELETE FROM pers_t
/
DELETE FROM rev_t
/
*/

INSERT INTO rev_t (rev_id)
VALUES (999)
/

INSERT INTO rev_t (rev_id)
VALUES (1)
/

INSERT INTO pers_t (vpers_id, beg_id, end_id, pers_id, pers_fio)   
VALUES (1, 1, 999, 1, '')
/

INSERT INTO doc_t (vdoc_id, beg_id, end_id, doc_id, write_date)   
VALUES (1, 1, 999, 1, '01.01.2024')
/

INSERT INTO doc_sp_t (vpos_id, beg_id, end_id, pos_id, vdoc_id, vpers_id)   
VALUES (1, 1, 999, 1, 1, 1)
/

INSERT INTO rev_t (rev_id)
VALUES (2)
/

INSERT INTO pers_t (vpers_id, beg_id, end_id, pers_id, pers_fio)   
VALUES (2, 2, 999, 2, '')
/

INSERT INTO doc_sp_t (vpos_id, beg_id, end_id, pos_id, vdoc_id, vpers_id)   
VALUES (2, 2, 999, 2, 1, 2)
/

---------------------------------
rev_t
  rev_id
    1
    2
---------------------------------
pers_t
  vpers_id beg_id end_id pers_id pers_fio
    1       1       999    1       
    2       2       999    2       
---------------------------------    
doc_t    
  vdoc_id beg_id end_id doc_id write_date
    1       1      999    1      01.01.2024
---------------------------------    
doc_sp_t    
  vpos_id beg_id end_id pos_id vdoc_id vpers_id
    1       1      999    1      1       1
    2       2      999    2      1       2
---------------------------------

INSERT INTO rev_t (rev_id)
VALUES (3)
/

INSERT INTO pers_t (vpers_id, beg_id, end_id, pers_id, pers_fio)   
VALUES (3, 3, 999, 3, '')
/

INSERT INTO doc_t (vdoc_id, beg_id, end_id, doc_id, write_date)   
VALUES (2, 3, 999, 2, '01.01.2025')
/

INSERT INTO doc_sp_t (vpos_id, beg_id, end_id, pos_id, vdoc_id, vpers_id)   
VALUES (3, 3, 999, 3, 2, 1)
/

INSERT INTO doc_sp_t (vpos_id, beg_id, end_id, pos_id, vdoc_id, vpers_id)   
VALUES (4, 3, 999, 4, 2, 2)
/

INSERT INTO doc_sp_t (vpos_id, beg_id, end_id, pos_id, vdoc_id, vpers_id)   
VALUES (5, 3, 999, 5, 2, 3)
/

INSERT INTO rev_t (rev_id)
VALUES (4)
/

INSERT INTO pers_t (vpers_id, beg_id, end_id, pers_id, pers_fio)   
VALUES (4, 4, 999, 1, '')
/

UPDATE pers_t SET end_id = 3 WHERE vpers_id = 1
/

INSERT INTO doc_sp_t (vpos_id, beg_id, end_id, pos_id, vdoc_id, vpers_id)   
VALUES (6, 4, 999, 3, 2, 4)
/

UPDATE doc_sp_t SET end_id = 3 WHERE vpos_id = 3
/
---------------------------------
rev_t
  rev_id
    1
    2
    3
    4
---------------------------------
pers_t
  vpers_id beg_id end_id pers_id pers_fio
    1       1       3      1       
    2       2       999    2           
    3       3       999    3       
    4       4       999    1           
---------------------------------    
doc_t    
  vdoc_id beg_id end_id doc_id write_date
    1       1      999    1      01.01.2024  
    2       3      999    2      01.01.2025    
---------------------------------    
doc_sp_t    
  vpos_id beg_id end_id pos_id vdoc_id vpers_id
    1       1      999    1      1       1
    2       2      999    2      1       2
    3       3      3      3      2       1
    4       3      999    4      2       2
    5       3      999    5      2       3
    6       4      999    3      2       4
---------------------------------

SELECT d.doc_id, d.write_date, sp.pos_id, p.pers_id, p.pers_fio FROM doc_t d INNER JOIN doc_sp_t sp ON sp.vdoc_id = d.vdoc_id INNER JOIN pers_t p ON p.vpers_id = sp.vpers_id
ORDER BY d.doc_id, sp.pos_id

doc_id write_date   pos_id pers_id pers_fio
  1      01.01.2024   1      1       
  1      01.01.2024   2      2       
  2      01.01.2025   3      1       
  2      01.01.2025   3      1       
  2      01.01.2025   4      2       
  2      01.01.2025   5      3       
---------------------------------

SELECT d.doc_id, d.write_date, sp.pos_id, p.pers_id, p.pers_fio FROM doc_t d INNER JOIN doc_sp_t sp ON sp.vdoc_id = d.vdoc_id INNER JOIN pers_t p ON p.vpers_id = sp.vpers_id, rev_t r
WHERE r.rev_id = 4 
  AND r.rev_id BETWEEN d.beg_id AND d.end_id
  AND r.rev_id BETWEEN sp.beg_id AND sp.end_id
ORDER BY d.doc_id, sp.pos_id

doc_id write_date   pos_id pers_id pers_fio
  1      01.01.2024   1      1       
  1      01.01.2024   2      2       
  2      01.01.2025   3      1       
  2      01.01.2025   4      2       
  2      01.01.2025   5      3       
---------------------------------

SELECT d.doc_id, d.write_date, sp.pos_id, p.pers_id, p.pers_fio FROM doc_t d INNER JOIN doc_sp_t sp ON sp.vdoc_id = d.vdoc_id INNER JOIN pers_t p ON p.vpers_id = sp.vpers_id, rev_t r
WHERE r.rev_id = 3 
  AND r.rev_id BETWEEN d.beg_id AND d.end_id
  AND r.rev_id BETWEEN sp.beg_id AND sp.end_id
  AND d.doc_id = 2
ORDER BY d.doc_id, sp.pos_id

doc_id write_date   pos_id pers_id pers_fio
  2      01.01.2025   3      1       
  2      01.01.2025   4      2       
  2      01.01.2025   5      3       
---------------------------------

