/*
DROP TABLE doc_sp_t
/
DROP TABLE doc_t
/
DROP TABLE pers_t
/
DROP TABLE ver_t
/
DROP TABLE rev_t
/
*/

CREATE TABLE rev_t (
  rev_id NUMBER PRIMARY KEY,
  ver_id NUMBER
)      
/
CREATE INDEX ix_rev_t ON rev_t (rev_id, ver_id)
/

CREATE TABLE ver_t (
  ver_id NUMBER PRIMARY KEY,
  rev_id NUMBER REFERENCES rev_t (rev_id)
)      
/

CREATE TABLE pers_t (
  vpers_id NUMBER PRIMARY KEY REFERENCES ver_t (ver_id),
  end_id  NUMBER REFERENCES ver_t (ver_id),
  pers_id NUMBER NOT NULL,
  pers_fio VARCHAR2(1000) NOT NULL
)      
/
CREATE INDEX ix_pers_t ON pers_t (vpers_id, end_id, pers_id)
/

CREATE TABLE doc_t (
  vdoc_id NUMBER PRIMARY KEY REFERENCES ver_t (ver_id),
  end_id  NUMBER REFERENCES ver_t (ver_id),
  doc_id NUMBER NOT NULL,
  write_date DATE NOT NULL    
)
/      
CREATE INDEX ix_doc_t ON doc_t (vdoc_id, end_id, doc_id)
/
      
CREATE TABLE doc_sp_t (
  vpos_id  NUMBER PRIMARY KEY REFERENCES ver_t (ver_id),
  end_id  NUMBER REFERENCES ver_t (ver_id),
  pos_id  NUMBER NOT NULL,
  vdoc_id  NUMBER NOT NULL REFERENCES doc_t (vdoc_id),
  vpers_id NUMBER NOT NULL REFERENCES pers_t (vpers_id)
)
/      
CREATE INDEX ix_doc_sp_t ON doc_sp_t (vpos_id, end_id, pos_id)
/
/*
DELETE FROM doc_sp_t
/
DELETE FROM doc_t
/
DELETE FROM pers_t
/
DELETE FROM ver_t
/
DELETE FROM rev_t
/
*/

INSERT INTO rev_t (rev_id)
VALUES (1)
/

INSERT INTO ver_t (ver_id, rev_id)
VALUES (1, 1)
/

INSERT INTO pers_t (vpers_id, end_id, pers_id, pers_fio)   
VALUES (1, null, 1, '')
/

INSERT INTO ver_t (ver_id, rev_id)
VALUES (2, 1)
/

INSERT INTO doc_t (vdoc_id, end_id, doc_id, write_date)   
VALUES (2, null, 1, '01.01.2024')
/

INSERT INTO rev_t (rev_id)
VALUES (2)
/

INSERT INTO ver_t (ver_id, rev_id)
VALUES (3, 2)
/

INSERT INTO doc_sp_t (vpos_id, end_id, pos_id, vdoc_id, vpers_id)   
VALUES (3, null, 1, 2, 1)
/

INSERT INTO ver_t (ver_id, rev_id)
VALUES (4, 2)
/

INSERT INTO pers_t (vpers_id, end_id, pers_id, pers_fio)   
VALUES (4, null, 2, '')
/

INSERT INTO ver_t (ver_id, rev_id)
VALUES (5, 2)
/

INSERT INTO doc_sp_t (vpos_id, end_id, pos_id, vdoc_id, vpers_id)   
VALUES (5, null, 2, 2, 4)
/

---------------------------------
rev_t
  rev_id
    1
    2
---------------------------------
pers_t
  vpers_id end_id pers_id pers_fio
    1       ?      1       
    4       ?      2       
---------------------------------    
doc_t    
  vdoc_id end_id doc_id write_date
    2       ?      1      01.01.2024
---------------------------------    
doc_sp_t    
  vpos_id end_id pos_id vdoc_id vpers_id
    3       ?      1      2       1
    5       ?      2      2       4
---------------------------------

INSERT INTO rev_t (rev_id)
VALUES (3)
/

INSERT INTO ver_t (ver_id, rev_id)
VALUES (6, 3)
/

INSERT INTO pers_t (vpers_id, end_id, pers_id, pers_fio)   
VALUES (6, null, 3, '')
/

INSERT INTO ver_t (ver_id, rev_id)
VALUES (7, 3)
/

INSERT INTO doc_t (vdoc_id, end_id, doc_id, write_date)   
VALUES (7, null, 2, '01.01.2025')
/

INSERT INTO ver_t (ver_id, rev_id)
VALUES (8, 3)
/

INSERT INTO doc_sp_t (vpos_id, end_id, pos_id, vdoc_id, vpers_id)   
VALUES (8, null, 3, 7, 1)
/

INSERT INTO ver_t (ver_id, rev_id)
VALUES (9, 3)
/

INSERT INTO doc_sp_t (vpos_id, end_id, pos_id, vdoc_id, vpers_id)   
VALUES (9, null, 4, 7, 4)
/

INSERT INTO ver_t (ver_id, rev_id)
VALUES (10, 3)
/

INSERT INTO doc_sp_t (vpos_id, end_id, pos_id, vdoc_id, vpers_id)   
VALUES (10, null, 5, 7, 6)
/

UPDATE rev_t SET ver_id = 10 WHERE rev_id = 3
/

INSERT INTO rev_t (rev_id)
VALUES (4)
/

INSERT INTO ver_t (ver_id, rev_id)
VALUES (11, 4)
/

INSERT INTO pers_t (vpers_id, end_id, pers_id, pers_fio)   
VALUES (11, null, 1, '')
/

UPDATE pers_t SET end_id = 11 WHERE vpers_id = 1
/

INSERT INTO ver_t (ver_id, rev_id)
VALUES (12, 4)
/

INSERT INTO doc_sp_t (vpos_id, end_id, pos_id, vdoc_id, vpers_id)   
VALUES (12, null, 3, 7, 11)
/

UPDATE doc_sp_t SET end_id = 12 WHERE vpos_id = 8
/

UPDATE rev_t SET ver_id = 12 WHERE rev_id = 4
/

---------------------------------
rev_t
  rev_id
    1
    2
    3
    4
---------------------------------
pers_t
  vpers_id end_id pers_id pers_fio
    1        11     1       
    4        ?      2           
    6        ?      3       
    11       ?      1           
---------------------------------    
doc_t    
  vdoc_id end_id doc_id write_date
    2       ?      1      01.01.2024  
    7       ?      2      01.01.2025    
---------------------------------    
doc_sp_t    
  vpos_id end_id pos_id vdoc_id vpers_id
    3       ?      1      2       1
    5       ?      2      2       4
    8       12     3      7       1
    9       ?      4      7       4
    10      ?      5      7       6
    12      ?      3      7       11
---------------------------------

SELECT d.doc_id, d.write_date, sp.pos_id, p.pers_id, p.pers_fio FROM doc_t d INNER JOIN doc_sp_t sp ON sp.vdoc_id = d.vdoc_id INNER JOIN pers_t p ON p.vpers_id = sp.vpers_id
ORDER BY d.doc_id, sp.pos_id

doc_id write_date   pos_id pers_id pers_fio
  1      01.01.2024   1      1       
  1      01.01.2024   2      2       
  2      01.01.2025   3      1       
  2      01.01.2025   3      1       
  2      01.01.2025   4      2       
  2      01.01.2025   5      3       
---------------------------------

SELECT d.doc_id, d.write_date, sp.pos_id, p.pers_id, p.pers_fio FROM doc_t d INNER JOIN doc_sp_t sp ON sp.vdoc_id = d.vdoc_id INNER JOIN pers_t p ON p.vpers_id = sp.vpers_id, rev_t r
WHERE r.rev_id = 4
  AND r.ver_id >= d.vdoc_id AND r.ver_id < COALESCE(d.end_id, r.ver_id +1)
  AND r.ver_id >= sp.vpos_id AND r.ver_id < COALESCE(sp.end_id, r.ver_id +1)
ORDER BY d.doc_id, sp.pos_id

doc_id write_date   pos_id pers_id pers_fio
  1      01.01.2024   1      1       
  1      01.01.2024   2      2       
  2      01.01.2025   3      1       
  2      01.01.2025   4      2       
  2      01.01.2025   5      3       
---------------------------------

SELECT d.doc_id, d.write_date, sp.pos_id, p.pers_id, p.pers_fio FROM doc_t d INNER JOIN doc_sp_t sp ON sp.vdoc_id = d.vdoc_id INNER JOIN pers_t p ON p.vpers_id = sp.vpers_id, rev_t r
WHERE r.rev_id = 3
  AND r.ver_id >= d.vdoc_id AND r.ver_id < COALESCE(d.end_id, r.ver_id +1)
  AND r.ver_id >= sp.vpos_id AND r.ver_id < COALESCE(sp.end_id, r.ver_id +1)  
  AND d.doc_id = 2
ORDER BY d.doc_id, sp.pos_id

doc_id write_date   pos_id pers_id pers_fio
  2      01.01.2025   3      1       
  2      01.01.2025   4      2       
  2      01.01.2025   5      3       
---------------------------------

